/**
* DevExtreme (cjs/renovation/ui/scheduler/utils/filtering/local.js)
* Version: 23.1.7
* Build date: Fri Apr 26 2024
*
* Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
"use strict";

exports.getFilterStrategy = void 0;
var _m_appointment_filter = require("../../../../../__internal/scheduler/appointments/data_provider/m_appointment_filter");
var getFilterStrategy = function getFilterStrategy(resources, startDayHour, endDayHour, cellDurationInMinutes, showAllDayPanel, supportAllDayRow, firstDayOfWeek, viewType, dateRange, groupCount, loadedResources, isVirtualScrolling, timeZoneCalculator, dataAccessors, viewDataProvider) {
  var filterOptions = {
    resources: resources,
    startDayHour: startDayHour,
    endDayHour: endDayHour,
    appointmentDuration: cellDurationInMinutes,
    showAllDayPanel: showAllDayPanel,
    supportAllDayRow: supportAllDayRow,
    firstDayOfWeek: firstDayOfWeek,
    viewType: viewType,
    viewDirection: 'vertical',
    dateRange: dateRange,
    groupCount: groupCount,
    loadedResources: loadedResources,
    isVirtualScrolling: isVirtualScrolling,
    timeZoneCalculator: timeZoneCalculator,
    dataSource: undefined,
    dataAccessors: dataAccessors,
    viewDataProvider: viewDataProvider
  };
  return isVirtualScrolling ? new _m_appointment_filter.AppointmentFilterVirtualStrategy(filterOptions) : new _m_appointment_filter.AppointmentFilterBaseStrategy(filterOptions);
};
exports.getFilterStrategy = getFilterStrategy;
